<?php
namespace Bushelpowered\Api\Data\Analytics\V1;

use \Bushelpowered\Api\Data\Analytics\V1\Request\UniqueVisitorsRequest;
use \Bushelpowered\Api\Data\Analytics\V1\Response\UniqueVisitorsListResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetUniqueVisitors 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(UniqueVisitorsRequest $request, $headers): UniqueVisitorsListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/data/analytics/v1/GetUniqueVisitors', $request, new GetUniqueVisitorsResponseWrapper(), $headers)->response;
    }
}

class GetUniqueVisitorsResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var UniqueVisitorsListResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.data.analytics.v1#GetUniqueVisitorsSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Data\Analytics\V1\Response\UniqueVisitorsListResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}