<?php
namespace Bushelpowered\Api\Fulfillment\Threshold\V1\Response;
        
class ThresholdDetailResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $commodityCode;
    public string $locationId;
    public string $remarkCode;
    public ?float $minValue = null;
    public ?float $maxValue = null;
    /** @var \Bushelpowered\Api\Fulfillment\Recipient\V1\Response\RecipientResponse[] $recipients */
    public array $recipients;
    public int $createdAt;
    public int $updatedAt;

    /**
     * @param  \Bushelpowered\Api\Fulfillment\Recipient\V1\Response\RecipientResponse[]  $recipients
     */
    public function __construct(string $id, string $commodityCode, string $locationId, string $remarkCode, ?float $minValue, ?float $maxValue, array $recipients, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->commodityCode = $commodityCode;
        $this->locationId = $locationId;
        $this->remarkCode = $remarkCode;
        $this->minValue = $minValue;
        $this->maxValue = $maxValue;
        $this->recipients = $recipients;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}