<?php
namespace Bushelpowered\Api\Fulfillment\Ticket\V1\Response;
        
class TicketResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public int $id;
    public string $remoteId;
    public ?string $displayId = null;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account = null;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location;
    public ?float $dockDollars = null;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\RemarkResponse[] $remarks */
    public array $remarks;
    public ?string $grader = null;
    public ?string $weighMaster = null;
    public ?string $truckName = null;
    public ?string $truckLicense = null;
    public ?string $truckDriver = null;
    public ?int $weighInAt = null;
    public ?int $weighOutAt = null;
    public ?int $remoteCreatedAt = null;
    public ?int $remoteUpdatedAt = null;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\SplitResponse[] $splits */
    public array $splits;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity;
    public ?string $amountsUom = null;
    public ?string $weightsUom = null;
    public ?float $grossAmount = null;
    public ?float $grossWeight = null;
    public ?float $netAmount = null;
    public ?float $netWeight = null;
    public ?float $shrinkAmount = null;
    public ?float $shrinkWeight = null;
    public ?float $dockAmount = null;
    public ?float $dockWeight = null;
    public ?float $tareWeight = null;
    /** @var \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\ExceededThresholdResponse[] $exceededThresholds */
    public array $exceededThresholds;
    public int $createdAt;
    public int $updatedAt;

    /**
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\RemarkResponse[]  $remarks
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\SplitResponse[]  $splits
     * @param  \Bushelpowered\Api\Fulfillment\Ticket\V1\Response\ExceededThresholdResponse[]  $exceededThresholds
     */
    public function __construct(int $id, string $remoteId, ?string $displayId, \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location, ?float $dockDollars, array $remarks, ?string $grader, ?string $weighMaster, ?string $truckName, ?string $truckLicense, ?string $truckDriver, ?int $weighInAt, ?int $weighOutAt, ?int $remoteCreatedAt, ?int $remoteUpdatedAt, array $splits, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity, ?string $amountsUom, ?string $weightsUom, ?float $grossAmount, ?float $grossWeight, ?float $netAmount, ?float $netWeight, ?float $shrinkAmount, ?float $shrinkWeight, ?float $dockAmount, ?float $dockWeight, ?float $tareWeight, array $exceededThresholds, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->account = $account;
        $this->company = $company;
        $this->location = $location;
        $this->dockDollars = $dockDollars;
        $this->remarks = $remarks;
        $this->grader = $grader;
        $this->weighMaster = $weighMaster;
        $this->truckName = $truckName;
        $this->truckLicense = $truckLicense;
        $this->truckDriver = $truckDriver;
        $this->weighInAt = $weighInAt;
        $this->weighOutAt = $weighOutAt;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->splits = $splits;
        $this->commodity = $commodity;
        $this->amountsUom = $amountsUom;
        $this->weightsUom = $weightsUom;
        $this->grossAmount = $grossAmount;
        $this->grossWeight = $grossWeight;
        $this->netAmount = $netAmount;
        $this->netWeight = $netWeight;
        $this->shrinkAmount = $shrinkAmount;
        $this->shrinkWeight = $shrinkWeight;
        $this->dockAmount = $dockAmount;
        $this->dockWeight = $dockWeight;
        $this->tareWeight = $tareWeight;
        $this->exceededThresholds = $exceededThresholds;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}