<?php
namespace Bushelpowered\Api\Grain\Contracts\V1\Model;
        
class PricingHistoryRaw implements Api\Common\Event\RawRecord, Api\Common\HasSourceTimestamps, Api\Common\Event\Syncable
{
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public string $sourcePricingLineId;
    public string $pricingLineIntegrationId;
    public ?string $sourceType = null;
    public ?float $sourcePrice = null;
    public ?string $sourcePricingMode = null;
    public ?string $sourceAccountId = null;
    public ?string $sourceLocationId = null;
    public int $sourceUpdatedAt;
    public int $sourceCreatedAt;
    public ?int $sourceDeletedAt = null;

    /**
     */
    public function __construct(string $tenantId, string $datasourceId, string $integrationId, string $sourceId, string $sourcePricingLineId, string $pricingLineIntegrationId, ?string $sourceType, ?float $sourcePrice, ?string $sourcePricingMode, ?string $sourceAccountId, ?string $sourceLocationId, int $sourceUpdatedAt, int $sourceCreatedAt, ?int $sourceDeletedAt)
    {
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourcePricingLineId = $sourcePricingLineId;
        $this->pricingLineIntegrationId = $pricingLineIntegrationId;
        $this->sourceType = $sourceType;
        $this->sourcePrice = $sourcePrice;
        $this->sourcePricingMode = $sourcePricingMode;
        $this->sourceAccountId = $sourceAccountId;
        $this->sourceLocationId = $sourceLocationId;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getSourceAccountId(): ?string
    {
        return $this->sourceAccountId;
    }
    public function getSourceLocationId(): ?string
    {
        return $this->sourceLocationId;
    }
    public function getSourceUpdatedAt(): int
    {
        return $this->sourceUpdatedAt;
    }
    public function getSourceCreatedAt(): int
    {
        return $this->sourceCreatedAt;
    }
    public function getSourceDeletedAt(): ?int
    {
        return $this->sourceDeletedAt;
    }
}