<?php

namespace Bushelpowered\Api\Iam\Access\Common\V1\Mixins;

class ResourceRef
{
    public string $type;
    private $data= null;
    private \JsonMapper $mapper;

    private $types = [
        'root' => '\Bushelpowered\Api\Common\EmptyPHP',
        'tenant' => '\Bushelpowered\Api\Iam\Access\Common\V1\TenantRef',
        'location' => '\Bushelpowered\Api\Iam\Access\Common\V1\LocationRef',
        'account' => '\Bushelpowered\Api\Iam\Access\Common\V1\AccountRef',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Root(\Bushelpowered\Api\Common\EmptyPHP $data): ResourceRef
    {
        return ResourceRef(root, $data);
    }
    public static function Tenant(\Bushelpowered\Api\Iam\Access\Common\V1\TenantRef $data): ResourceRef
    {
        return ResourceRef(tenant, $data);
    }
    public static function Location(\Bushelpowered\Api\Iam\Access\Common\V1\LocationRef $data): ResourceRef
    {
        return ResourceRef(location, $data);
    }
    public static function Account(\Bushelpowered\Api\Iam\Access\Common\V1\AccountRef $data): ResourceRef
    {
        return ResourceRef(account, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    