<?php

namespace Bushelpowered\Api\Iam\Access\Common\V1;

class SubjectOrIdentifier
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        'subject' => '\Bushelpowered\Api\Iam\Access\Common\V1\SubjectRef',
        'identifier' => '\Bushelpowered\Api\Iam\Access\Common\V1\IdentifierRef',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Subject(\Bushelpowered\Api\Iam\Access\Common\V1\SubjectRef $data): SubjectOrIdentifier
    {
        return SubjectOrIdentifier(subject, $data);
    }
    public static function Identifier(\Bushelpowered\Api\Iam\Access\Common\V1\IdentifierRef $data): SubjectOrIdentifier
    {
        return SubjectOrIdentifier(identifier, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    