<?php

namespace Bushelpowered\Api\Iam\Access\Manage\V1\Request;

class Relationship
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        'tenantToRoot' => '\Bushelpowered\Api\Iam\Access\Manage\V1\Request\TenantToRootRelationship',
        'locationToTenant' => '\Bushelpowered\Api\Iam\Access\Manage\V1\Request\LocationToTenantRelationship',
        'locationToLocation' => '\Bushelpowered\Api\Iam\Access\Manage\V1\Request\LocationToLocationRelationship',
        'accountToTenant' => '\Bushelpowered\Api\Iam\Access\Manage\V1\Request\AccountToTenantRelationship',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function TenantToRoot(\Bushelpowered\Api\Iam\Access\Manage\V1\Request\TenantToRootRelationship $data): Relationship
    {
        return Relationship(tenantToRoot, $data);
    }
    public static function LocationToTenant(\Bushelpowered\Api\Iam\Access\Manage\V1\Request\LocationToTenantRelationship $data): Relationship
    {
        return Relationship(locationToTenant, $data);
    }
    public static function LocationToLocation(\Bushelpowered\Api\Iam\Access\Manage\V1\Request\LocationToLocationRelationship $data): Relationship
    {
        return Relationship(locationToLocation, $data);
    }
    public static function AccountToTenant(\Bushelpowered\Api\Iam\Access\Manage\V1\Request\AccountToTenantRelationship $data): Relationship
    {
        return Relationship(accountToTenant, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    