<?php

namespace Bushelpowered\Api\Platform\Branding\V1\Request;

class BuildType
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        'release' => '\Bushelpowered\Api\Common\EmptyPHP',
        'uat' => '\Bushelpowered\Api\Common\EmptyPHP',
        'qa' => '\Bushelpowered\Api\Common\EmptyPHP',
        'demo' => '\Bushelpowered\Api\Common\EmptyPHP',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Release(\Bushelpowered\Api\Common\EmptyPHP $data): BuildType
    {
        return BuildType(release, $data);
    }
    public static function Uat(\Bushelpowered\Api\Common\EmptyPHP $data): BuildType
    {
        return BuildType(uat, $data);
    }
    public static function Qa(\Bushelpowered\Api\Common\EmptyPHP $data): BuildType
    {
        return BuildType(qa, $data);
    }
    public static function Demo(\Bushelpowered\Api\Common\EmptyPHP $data): BuildType
    {
        return BuildType(demo, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    