<?php

namespace Bushelpowered\Api\Platform\Branding\V1\Request;

class IosLane
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        'internalBuild' => '\Bushelpowered\Api\Common\EmptyPHP',
        'internalTestflight' => '\Bushelpowered\Api\Common\EmptyPHP',
        'externalDebug' => '\Bushelpowered\Api\Common\EmptyPHP',
        'externalStaging' => '\Bushelpowered\Api\Common\EmptyPHP',
        'externalDemo' => '\Bushelpowered\Api\Common\EmptyPHP',
        'externalRelease' => '\Bushelpowered\Api\Common\EmptyPHP',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function InternalBuild(\Bushelpowered\Api\Common\EmptyPHP $data): IosLane
    {
        return IosLane(internalBuild, $data);
    }
    public static function InternalTestflight(\Bushelpowered\Api\Common\EmptyPHP $data): IosLane
    {
        return IosLane(internalTestflight, $data);
    }
    public static function ExternalDebug(\Bushelpowered\Api\Common\EmptyPHP $data): IosLane
    {
        return IosLane(externalDebug, $data);
    }
    public static function ExternalStaging(\Bushelpowered\Api\Common\EmptyPHP $data): IosLane
    {
        return IosLane(externalStaging, $data);
    }
    public static function ExternalDemo(\Bushelpowered\Api\Common\EmptyPHP $data): IosLane
    {
        return IosLane(externalDemo, $data);
    }
    public static function ExternalRelease(\Bushelpowered\Api\Common\EmptyPHP $data): IosLane
    {
        return IosLane(externalRelease, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    