<?php
namespace Bushelpowered\Api\Platform\Commodity\V1\Model;
        
class TenantCommodityStandard implements Api\Common\Event\StandardRecord, Api\Common\HasSourceTimestamps, Api\Common\HasTimestamps
{
    public string $id;
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceLocationId = null;
    public ?string $locationId = null;
    public ?string $sourceDisplayName = null;
    public ?string $displayName = null;
    public ?string $commodityId = null;
    public ?string $className = null;
    public ?string $groupName = null;
    public ?string $subgroupName = null;
    public ?string $varietyName = null;
    public ?string $accountId = null;
    public int $updatedAt;
    public int $createdAt;
    public ?int $deletedAt = null;
    public int $sourceCreatedAt;
    public int $sourceUpdatedAt;
    public ?int $sourceDeletedAt = null;

    /**
     */
    public function __construct(string $id, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceLocationId, ?string $locationId, ?string $sourceDisplayName, ?string $displayName, ?string $commodityId, ?string $className, ?string $groupName, ?string $subgroupName, ?string $varietyName, ?string $accountId, int $updatedAt, int $createdAt, ?int $deletedAt, int $sourceCreatedAt, int $sourceUpdatedAt, ?int $sourceDeletedAt)
    {
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceLocationId = $sourceLocationId;
        $this->locationId = $locationId;
        $this->sourceDisplayName = $sourceDisplayName;
        $this->displayName = $displayName;
        $this->commodityId = $commodityId;
        $this->className = $className;
        $this->groupName = $groupName;
        $this->subgroupName = $subgroupName;
        $this->varietyName = $varietyName;
        $this->accountId = $accountId;
        $this->updatedAt = $updatedAt;
        $this->createdAt = $createdAt;
        $this->deletedAt = $deletedAt;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
    }
    
    public function getId(): string
    {
        return $this->id;
    }
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
    public function getAccountId(): ?string
    {
        return $this->accountId;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
    public function getSourceCreatedAt(): int
    {
        return $this->sourceCreatedAt;
    }
    public function getSourceUpdatedAt(): int
    {
        return $this->sourceUpdatedAt;
    }
    public function getSourceDeletedAt(): ?int
    {
        return $this->sourceDeletedAt;
    }
}